structure Ctx:> CTX = struct
  type k = string
  type v = Typ.t
  type t = (k * v) list

  fun empty (): t = []

  fun add (k: k) (v: v) (x: t): t =
    case x of
      [] => [(k, v)]
    | (k1, v1) :: x => if k = k1 then (k, v) :: x else (k1, v1) :: add k v x

  fun get (k: k) (x: t): v option =
    case x of
      [] => NONE
    | (k1, v1) :: x => if k = k1 then SOME v1 else get k x

  fun f ((k, v): k * v): string = k ^ " => " ^ Typ.toString v

  fun toString (x: t): string =
    "{" ^ String.concatWith ", " (List.map f x) ^ "}"
end
